package de.szut.casino.user;

import jakarta.persistence.Column;
import jakarta.persistence.Entity;
import jakarta.persistence.GeneratedValue;
import jakarta.persistence.Id;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

import java.math.BigDecimal;

@Setter
@Getter
@Entity
@NoArgsConstructor
public class UserEntity {
    @Id
    @GeneratedValue
    private Long id;
    @Column(unique = true)
    private String keycloakId;
    private String username;

    @Column(precision = 19, scale = 2)
    private BigDecimal balance;

    public UserEntity(String keycloakId, String username, BigDecimal balance) {
        this.keycloakId = keycloakId;
        this.username = username;
        this.balance = balance;
    }

    public void addBalance(long amountInCents) {
        BigDecimal amountToAdd = BigDecimal.valueOf(amountInCents).movePointLeft(2);

        if (this.balance == null) {
            this.balance = amountToAdd;
        } else {
            this.balance = this.balance.add(amountToAdd);
        }
    }
}
